<script>

  import { getContext, onMount, onDestroy  } from 'svelte';
  import MenuItem                            from './MenuItem.svelte';
  import MenuItemSlider                      from './MenuItemSlider.svelte';
  import MenuItemInput                       from './MenuItemInput.svelte';
  import MenuItemCheck                       from './MenuItemCheck.svelte';

  export const itemTypes = {
    default: MenuItem,
    slider : MenuItemSlider,
    input  : MenuItemInput,
    check  : MenuItemCheck,
  };

  export let menu     = null;
  export let name     = 'menu-item';
  export let type     = 'default';
  export let label    = 'Menu item';
  export let value    = null;
  export let index    = -1;
  export let depth    = 0;
  export let path     = [];
  export let children = [];
  export let classes  = [];

  const mainContext = getContext('main');

  if(children.length > 0)
    classes.push('has-children');

  classes.push(`depth-${depth}`);

  path = path.slice(0);

  path.push(index);

  export const reset = function(e) {

    let idx = classes.indexOf('active');

    if(idx !== -1)
      classes.splice(idx, 1);

    classes = classes.slice(0);
  }

  export const onItemClick = function(e) {
    
    e.preventDefault();

    if(children.length > 0) {

      const idx = classes.indexOf('active');

      if(idx === -1)
        classes.push('active');

      classes = classes.slice(0);
      
    }

  }

  export const onLabelClick = function(e) {
    e.preventDefault();
    mainContext.reset();
    window.parent.postMessage(JSON.stringify({action: 'menu_select', data: {name, type, label, value, index, depth, path}}), '*');
  }

  onMount(() => {
    mainContext.registerReset(reset);
  });

  onDestroy(() => {
    mainContext.unregisterReset(reset);
  });

</script>

<style>
  
  .menu-item {
    display: flex;
    flex-direction: column;
    height: 1070px;
    margin-bottom: -1035px;
    line-height: 35px;
    width: 0;
    user-select: none;
    cursor: default;
    position: relative;
    overflow: visible;
  }
  
  .menu-item:nth-child(even) > .label {
    background-color: rgba(0, 0, 0, 0.85);
  }

  .menu-item .label > .before > span::before, .menu-item .label > .after > span::before {
    content: '';
    padding: 0 5px 0 5px;
    display: inline-block;
    height: 35px;
    line-height: 35px;
  }

  .menu-item > .label {
    color: #fff;
    background-color: rgba(0, 0, 0, 0.75);
    height: 25px;
    padding: 0 5px 10px 5px;
    border-left: 1px solid rgba(143, 75, 75, 0.75);
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    white-space: nowrap;
  }

  .menu-item.has-children > .label > .after > span::before {
    content: '→';
  }

  .menu-item > .label > div > span {
    text-align: left;
    white-space: nowrap;
  }

  .menu-item > .label > .before {
    width: 35px;
  }

  .menu-item > .label > .after {
    flex-grow: 1;
    text-align: right;
  }

  .menu-item > .label > .before > ::before, .menu-item > .label .after > span::before {
    color: rgb(143, 75, 75);
    text-align: center;
    white-space: nowrap;
    display: inline;
  }

  .menu-item.active > .label > .before > span::before, .menu-item.active:hover > .label > .before > span::before {
    content: "★";
  }

  .menu-item:hover > .label > .before > span::before {
    color:rgb(143, 75, 75);
    content: "●";
  }

  .label-children {
    display: none;
    flex-direction: column;
    position: relative;
    margin-left: 211px;
    margin-top: -35px;
  }

  .menu-item.active > .label-children {
    display: flex;
  }

	.label {
		color: #000;
  }

  .label > div > span:hover {
    cursor: pointer;
  }

</style>

<div class={`menu-item ${classes.join(' ')}`} on:click={onItemClick}>

  <div class="label" on:click={onLabelClick}>
    <div class="before"><span/></div>
    <div class="content"><span>{label}</span></div>
    <div class="after"><span/></div>
  </div>

  <div class="label-children">
    {#each children as item, index}
      <svelte:component this={itemTypes[item.type || 'default']} {...item} {menu} {index} {path} depth={depth + 1}/>
    {/each}
  </div>

</div>
